﻿Imports System.Data.OleDb
Imports System.Runtime.InteropServices
Imports System.IO

Public Class Form1

    'For Universal Library
    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Public UlStat As MccDaq.ErrorInfo
    Dim LastCounterValue As Int32 = 0
    Dim bFirstEntry As Boolean = False

    'For database
    Dim sConnectionString As String
    Public objConn As New OleDbConnection()
    Dim daMFGData As New OleDbDataAdapter()
    Dim dsNewScan As New DataSet()
    Dim dtData As DataTable
    Dim tblTestData As DataTable
    Dim drCurrent As DataRow

    'For FileIO
    Dim DatabaseFileNameAndPath As String
    Dim Filename As String
    Dim SettingsFileOut As IO.StreamWriter
    Dim SettingsFileIn As IO.StreamReader

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)

        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("2408") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No USB-2408 series board found in system. ", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        UlStat = Daqboard.FlashLED()
        Dim MyBoardName As String = Daqboard.BoardName.Trim
        Me.Text = MyBoardName + " found as board number: " + Daqboard.BoardNum.ToString

        'Create the local database to DataGridView1
        CreateDataBase()

        'Get file path to user's "MyDocuments\OledbExample\"
        Dim pathstring As String = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        pathstring = pathstring + "\Measurement Computing\OledbExample\"
        System.IO.Directory.CreateDirectory(pathstring)

        'Greate a file.
        Filename = ""
        Filename = pathstring + "Database.CFG"

        'read the data from the file and parse it.
        Try
            SettingsFileIn = New StreamReader(Filename)
            DatabaseFileNameAndPath = SettingsFileIn.ReadLine()
            SettingsFileIn.Close()

        Catch ex As Exception

        End Try
    End Sub

    Private Sub CreateDataBase()
        Dim ds As New DataSet
        ds = CreateDataSet()
        DataGridView1.DataSource = ds.Tables("MeasuredData")
    End Sub

    Private Function CreateDataSet() As DataSet
        'creating a DataSet object for tables
        Dim MeasuredData As DataSet = New DataSet()

        ' creating a table object
        Dim dtData As DataTable = CreateDACTable()
        MeasuredData.Tables.Add(dtData)
        Return MeasuredData
    End Function

    Private Function CreateDACTable() As DataTable

        dtData = New DataTable("MeasuredData")
        ' adding columns
        AddNewColumn(dtData, "System.String", "Time")
        AddNewColumn(dtData, "System.String", "Temperature")
        AddNewColumn(dtData, "System.String", "Pressure")
        AddNewColumn(dtData, "System.String", "Tachometer")
        AddNewColumn(dtData, "System.String", "Interlock")

        Return dtData
    End Function

    Private Sub AddNewColumn(ByRef table As DataTable, ByVal columnType As String, ByVal columnName As String)
        Dim column As DataColumn = table.Columns.Add(columnName, Type.GetType(columnType))
    End Sub

    Private Sub btnStartStop_Click(sender As System.Object, e As System.EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            OpenDatabase()
            UlStat = Daqboard.CClear(0)

            Timer1.Enabled = True
        Else
            btnStartStop.Text = "Start"
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub OpenDatabase()
        'How to open an oleDB data base
        sConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & DatabaseFileNameAndPath   'c:\Users\Public\Documents\MCCGenericOdbc.mdb"   'for oleDB
        objConn = New OleDbConnection(sConnectionString)
        objConn.Open()

        daMFGData = New OleDbDataAdapter("Select * From TestData", objConn)
        dsNewScan = New DataSet("NewScan")
        daMFGData.FillSchema(dsNewScan, SchemaType.Source, "TestData")
        daMFGData.Fill(dsNewScan, "TestData")

        ' Create a new instance of a DataTable.
        tblTestData = dsNewScan.Tables("TestData")

        objConn.Close()
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim MyDataScan(4) As Object 'array to hold the data generated by the scan 

        'Read the temperature 
        UlStat = Daqboard.TIn(0, MccDaq.TempScale.Celsius, MyDataScan(1), MccDaq.VInOptions.Default)
        If UlStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(UlStat)
            Exit Sub
        End If
        Thermometer1.TempValue = MyDataScan(1)
        lblTempValue.Text = Convert.ToDouble(MyDataScan(1)).ToString("##0.00") & " °C"

        'Read the voltage (Pressure)
        UlStat = Daqboard.VIn(1, MccDaq.Range.Bip10Volts, MyDataScan(2), MccDaq.VInOptions.Default)
        If UlStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(UlStat)
            Exit Sub
        End If
        MyDataScan(2) *= 10  'apply scaling (Makes the data look cooler, it uses more of the pressure meter!)
        lblPressure.Text = Convert.ToSingle(MyDataScan(2)).ToString("##0.00")
        kdPressure.UpdateKnob(MyDataScan(2))

        'Read the counter (Tachometer)
        UlStat = Daqboard.CIn(0, MyDataScan(3))
        If UlStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(UlStat)
            Exit Sub
        End If
        Dim NewCountRead As Integer = (MyDataScan(3) - LastCounterValue)
        LastCounterValue = MyDataScan(3)
        Dim TachVal As Double = (NewCountRead * 60) 'Apply scaling to RPM from RPS
        kdTach.UpdateKnob(TachVal / 100)
        lblTach.Text = (TachVal).ToString("####0")

        'Read the digital bit (door interlock)
        Dim MyDigBit As Boolean
        UlStat = Daqboard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 0, MyDigBit)
        If UlStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(UlStat)
            Exit Sub
        End If
        Led1.Value = MyDigBit
        MyDataScan(4) = "0"
        If MyDigBit = True Then MyDataScan(4) = "1"

        'Read the current Time
        MyDataScan(0) = Convert.ToString(System.DateTime.Now)
        lblTime.Text = MyDataScan(0)

        'This goes to the datagrid
        If bFirstEntry = False Then
            Dim newrow As DataRow = dtData.NewRow()

            newrow("Time") = MyDataScan(0)
            newrow("Temperature") = MyDataScan(1).ToString()
            newrow("Pressure") = MyDataScan(2).ToString
            newrow("Tachometer") = TachVal.ToString
            newrow("Interlock") = MyDataScan(4)
            dtData.Rows.Add(newrow)

            bFirstEntry = True
        Else
            Dim drEditRow As DataRow
            drEditRow = dtData.NewRow()

            drEditRow = dtData.Rows.Item(0)
            drEditRow.BeginEdit()
            drEditRow("Time") = DateTime.Now.ToString()
            drEditRow("Temperature") = Format(MyDataScan(1), "##0.0#")
            drEditRow("Pressure") = Format(MyDataScan(2), "##0.0#")
            drEditRow("Tachometer") = Format(TachVal, "####")
            drEditRow("Interlock") = MyDataScan(4)
            drEditRow.EndEdit()
        End If

        Try  'This goes out to the database
            objConn.Open()

            ' Obtain a new DataRow object from the DataTable.
            drCurrent = tblTestData.NewRow()
            drCurrent = tblTestData.Rows.Find(1)
            drCurrent = tblTestData.Rows(0)
            drCurrent.BeginEdit()
            drCurrent("Time") = DateTime.Now.ToString()
            drCurrent("Temperature") = MyDataScan(1).ToString()
            drCurrent("Pressure") = Format(MyDataScan(2), "##0.0#")
            drCurrent("Tachometer") = TachVal
            drCurrent("Interlock") = MyDataScan(4)
            drCurrent.EndEdit()

            Dim objCommandBuilder As New OleDbCommandBuilder(daMFGData)
            objCommandBuilder.QuotePrefix = "["
            objCommandBuilder.QuoteSuffix = "]"

            Dim r As Integer = daMFGData.Update(dsNewScan, "TestData")
            objConn.Close()

        Catch ex As OleDbException
            Timer1.Enabled = False
            objConn.Close()
            MsgBox(ex.Message.ToString(), MsgBoxStyle.Information, "Error Message")
        End Try
    End Sub

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler
        Timer1.Enabled = False
        Try
            objConn.Close()
        Catch ex As Exception

        End Try
        MessageBox.Show(ulstat.Message, "Universal Library Error ", MessageBoxButtons.OK, MessageBoxIcon.Error)
        btnStartStop.Text = "Start"
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Timer1.Enabled = False
        End
    End Sub

    Private Sub btnEnd_Click(sender As System.Object, e As System.EventArgs) Handles btnEnd.Click
        Timer1.Enabled = False
        End
    End Sub

    Private Sub SelectDatabaseToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles SelectDatabaseToolStripMenuItem.Click
        OpenFileDialog1.Filter = "MS ACCESS (*.mdb)|*.mdb|All Files (*.*)|*.*"
        OpenFileDialog1.FileName = DatabaseFileNameAndPath
        OpenFileDialog1.ShowDialog(Me)
        DatabaseFileNameAndPath = OpenFileDialog1.FileName

        If DatabaseFileNameAndPath = "" Then
            MsgBox("No file selected or bad file name selected.", MsgBoxStyle.OkOnly, "Bad file name")
            Exit Sub
        End If

        'Create a file path to user's "MyDocuments\OledbExample\"
        Dim pathstring As String = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        pathstring = pathstring + "\Measurement Computing\OledbExample\"
        System.IO.Directory.CreateDirectory(pathstring)

        'Create the file.
        Filename = pathstring + "Database.CFG"
        SettingsFileOut = New StreamWriter(Filename)

        'Write the DATABASE filename and path to the .cfg file
        SettingsFileOut.WriteLine(DatabaseFileNameAndPath)
        SettingsFileOut.Close()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        AboutBox1.Show(Me)
    End Sub
End Class
